(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('feature-toggle-service'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-feature-toggle', ['exports', '@angular/core', 'feature-toggle-service', '@angular/common'], factory) :
    (global = global || self, factory(global['ngx-feature-toggle'] = {}, global.ng.core, global.FeatureToggleService, global.ng.common));
}(this, function (exports, core, featureToggleService, common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FeatureToggleDirective = /** @class */ (function () {
        function FeatureToggleDirective(templateRef, viewContainer) {
            this.templateRef = templateRef;
            this.viewContainer = viewContainer;
            this.isOn = false;
        }
        /**
         * @return {?}
         */
        FeatureToggleDirective.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            if (!this.featureToggle) {
                throw new Error('Attribute `featureToggle` should not be null or empty');
            }
            this.shouldRender();
        };
        /**
         * @return {?}
         */
        FeatureToggleDirective.prototype.ngDoCheck = /**
         * @return {?}
         */
        function () {
            if (this.isOn !== featureToggleService.isOn(this.featureToggle)) {
                this.shouldRender();
            }
        };
        /**
         * @private
         * @return {?}
         */
        FeatureToggleDirective.prototype.shouldRender = /**
         * @private
         * @return {?}
         */
        function () {
            this.isOn = featureToggleService.isOn(this.featureToggle);
            if (this.isOn) {
                this.viewContainer.createEmbeddedView(this.templateRef);
            }
            else {
                this.viewContainer.clear();
            }
        };
        FeatureToggleDirective.decorators = [
            { type: core.Directive, args: [{
                        // tslint:disable-next-line: directive-selector
                        selector: '[featureToggle]',
                    },] }
        ];
        /** @nocollapse */
        FeatureToggleDirective.ctorParameters = function () { return [
            { type: core.TemplateRef },
            { type: core.ViewContainerRef }
        ]; };
        FeatureToggleDirective.propDecorators = {
            featureToggle: [{ type: core.Input }]
        };
        return FeatureToggleDirective;
    }());
    if (false) {
        /** @type {?} */
        FeatureToggleDirective.prototype.featureToggle;
        /**
         * @type {?}
         * @private
         */
        FeatureToggleDirective.prototype.isOn;
        /**
         * @type {?}
         * @private
         */
        FeatureToggleDirective.prototype.templateRef;
        /**
         * @type {?}
         * @private
         */
        FeatureToggleDirective.prototype.viewContainer;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FeatureToggleWhenDisabledDirective = /** @class */ (function () {
        function FeatureToggleWhenDisabledDirective(templateRef, viewContainer) {
            this.templateRef = templateRef;
            this.viewContainer = viewContainer;
            this.isOn = false;
        }
        /**
         * @return {?}
         */
        FeatureToggleWhenDisabledDirective.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            if (!this.featureToggleWhenDisabled) {
                throw new Error('Attribute `featureToggleWhenDisabled` should not be null or empty');
            }
            this.shouldRender();
        };
        /**
         * @return {?}
         */
        FeatureToggleWhenDisabledDirective.prototype.ngDoCheck = /**
         * @return {?}
         */
        function () {
            if (this.isOn !== featureToggleService.isOn(this.featureToggleWhenDisabled)) {
                this.shouldRender();
            }
        };
        /**
         * @return {?}
         */
        FeatureToggleWhenDisabledDirective.prototype.shouldRender = /**
         * @return {?}
         */
        function () {
            this.isOn = featureToggleService.isOn(this.featureToggleWhenDisabled);
            if (!this.isOn) {
                this.viewContainer.createEmbeddedView(this.templateRef);
            }
            else {
                this.viewContainer.clear();
            }
        };
        FeatureToggleWhenDisabledDirective.decorators = [
            { type: core.Directive, args: [{
                        // tslint:disable-next-line: directive-selector
                        selector: '[featureToggleWhenDisabled]',
                    },] }
        ];
        /** @nocollapse */
        FeatureToggleWhenDisabledDirective.ctorParameters = function () { return [
            { type: core.TemplateRef },
            { type: core.ViewContainerRef }
        ]; };
        FeatureToggleWhenDisabledDirective.propDecorators = {
            featureToggleWhenDisabled: [{ type: core.Input }]
        };
        return FeatureToggleWhenDisabledDirective;
    }());
    if (false) {
        /** @type {?} */
        FeatureToggleWhenDisabledDirective.prototype.featureToggleWhenDisabled;
        /**
         * @type {?}
         * @private
         */
        FeatureToggleWhenDisabledDirective.prototype.isOn;
        /**
         * @type {?}
         * @private
         */
        FeatureToggleWhenDisabledDirective.prototype.templateRef;
        /**
         * @type {?}
         * @private
         */
        FeatureToggleWhenDisabledDirective.prototype.viewContainer;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FeatureToggleProviderComponent = /** @class */ (function () {
        function FeatureToggleProviderComponent() {
            this.features = {};
            this.currentConfig = {};
        }
        /**
         * @return {?}
         */
        FeatureToggleProviderComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            if (typeof this.features !== 'object') {
                throw new Error('Attribute `features` should not be null or empty');
            }
            this.setFeatureToggles();
        };
        /**
         * @return {?}
         */
        FeatureToggleProviderComponent.prototype.ngDoCheck = /**
         * @return {?}
         */
        function () {
            this.setFeatureToggles();
        };
        /**
         * @private
         * @return {?}
         */
        FeatureToggleProviderComponent.prototype.setFeatureToggles = /**
         * @private
         * @return {?}
         */
        function () {
            if (this.currentConfig !== this.features) {
                this.currentConfig = this.features;
                featureToggleService.set(this.features);
            }
        };
        FeatureToggleProviderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'feature-toggle-provider',
                        template: "\n    <ng-content></ng-content>\n  "
                    }] }
        ];
        FeatureToggleProviderComponent.propDecorators = {
            features: [{ type: core.Input }]
        };
        return FeatureToggleProviderComponent;
    }());
    if (false) {
        /** @type {?} */
        FeatureToggleProviderComponent.prototype.features;
        /**
         * @type {?}
         * @private
         */
        FeatureToggleProviderComponent.prototype.currentConfig;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FeatureToggleModule = /** @class */ (function () {
        function FeatureToggleModule() {
        }
        FeatureToggleModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [FeatureToggleProviderComponent, FeatureToggleDirective, FeatureToggleWhenDisabledDirective],
                        exports: [FeatureToggleProviderComponent, FeatureToggleDirective, FeatureToggleWhenDisabledDirective],
                        imports: [common.CommonModule],
                    },] }
        ];
        return FeatureToggleModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxFeatureToggleCanActivateGuard = /** @class */ (function () {
        function NgxFeatureToggleCanActivateGuard() {
        }
        /**
         * @return {?}
         */
        NgxFeatureToggleCanActivateGuard.prototype.isDevMode = /**
         * @return {?}
         */
        function () {
            return core.isDevMode();
        };
        /**
         * @param {?} route
         * @return {?}
         */
        NgxFeatureToggleCanActivateGuard.prototype.canActivate = /**
         * @param {?} route
         * @return {?}
         */
        function (route) {
            /** @type {?} */
            var DEV_MODE = this.isDevMode();
            if (!route || !route.data || !route.data.featureToggle) {
                if (DEV_MODE) {
                    console.error('`NgxFeatureToggleCanActivateGuard` need to receive `featureToggle` as data in your route configuration.');
                }
                return false;
            }
            if (!Array.isArray(route.data.featureToggle)) {
                if (DEV_MODE) {
                    console.error('`NgxFeatureToggleCanActivateGuard` need to receive `featureToggle` as data as an array in your route configuration.');
                }
                return false;
            }
            /** @type {?} */
            var userCanAccess = route.data.featureToggle.every((/**
             * @param {?} toggle
             * @return {?}
             */
            function (toggle) {
                return toggle[0] === '!' ? !featureToggleService.isOn(toggle.replace('!', '')) : featureToggleService.isOn(toggle);
            }));
            return userCanAccess;
        };
        NgxFeatureToggleCanActivateGuard.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ NgxFeatureToggleCanActivateGuard.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function NgxFeatureToggleCanActivateGuard_Factory() { return new NgxFeatureToggleCanActivateGuard(); }, token: NgxFeatureToggleCanActivateGuard, providedIn: "root" });
        return NgxFeatureToggleCanActivateGuard;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxFeatureToggleCanActivateChildGuard = /** @class */ (function () {
        function NgxFeatureToggleCanActivateChildGuard() {
        }
        /**
         * @return {?}
         */
        NgxFeatureToggleCanActivateChildGuard.prototype.isDevMode = /**
         * @return {?}
         */
        function () {
            return core.isDevMode();
        };
        /**
         * @param {?} route
         * @return {?}
         */
        NgxFeatureToggleCanActivateChildGuard.prototype.canActivateChild = /**
         * @param {?} route
         * @return {?}
         */
        function (route) {
            /** @type {?} */
            var DEV_MODE = this.isDevMode();
            if (!route || !route.data || !route.data.featureToggle) {
                if (DEV_MODE) {
                    console.error('`NgxFeatureToggleCanActivateChildGuard` need to receive `featureToggle` as data in your route configuration.');
                }
                return false;
            }
            if (!Array.isArray(route.data.featureToggle)) {
                if (DEV_MODE) {
                    console.error('`NgxFeatureToggleCanActivateChildGuard` need to receive `featureToggle` as data as an array in your route configuration.');
                }
                return false;
            }
            /** @type {?} */
            var userCanAccess = route.data.featureToggle.every((/**
             * @param {?} toggle
             * @return {?}
             */
            function (toggle) {
                return toggle[0] === '!' ? !featureToggleService.isOn(toggle.replace('!', '')) : featureToggleService.isOn(toggle);
            }));
            return userCanAccess;
        };
        NgxFeatureToggleCanActivateChildGuard.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ NgxFeatureToggleCanActivateChildGuard.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function NgxFeatureToggleCanActivateChildGuard_Factory() { return new NgxFeatureToggleCanActivateChildGuard(); }, token: NgxFeatureToggleCanActivateChildGuard, providedIn: "root" });
        return NgxFeatureToggleCanActivateChildGuard;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxFeatureToggleCanLoadGuard = /** @class */ (function () {
        function NgxFeatureToggleCanLoadGuard() {
        }
        /**
         * @return {?}
         */
        NgxFeatureToggleCanLoadGuard.prototype.isDevMode = /**
         * @return {?}
         */
        function () {
            return core.isDevMode();
        };
        /**
         * @param {?} route
         * @return {?}
         */
        NgxFeatureToggleCanLoadGuard.prototype.canLoad = /**
         * @param {?} route
         * @return {?}
         */
        function (route) {
            /** @type {?} */
            var DEV_MODE = this.isDevMode();
            if (!route || !route.data || !route.data.featureToggle) {
                if (DEV_MODE) {
                    console.error('`NgxFeatureToggleCanLoadGuard` need to receive `featureToggle` as data in your route configuration.');
                }
                return false;
            }
            if (!Array.isArray(route.data.featureToggle)) {
                if (DEV_MODE) {
                    console.error('`NgxFeatureToggleCanLoadGuard` need to receive `featureToggle` as data as an array in your route configuration.');
                }
                return false;
            }
            /** @type {?} */
            var userCanAccess = route.data.featureToggle.every((/**
             * @param {?} toggle
             * @return {?}
             */
            function (toggle) {
                return toggle[0] === '!' ? !featureToggleService.isOn(toggle.replace('!', '')) : featureToggleService.isOn(toggle);
            }));
            return userCanAccess;
        };
        NgxFeatureToggleCanLoadGuard.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ NgxFeatureToggleCanLoadGuard.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function NgxFeatureToggleCanLoadGuard_Factory() { return new NgxFeatureToggleCanLoadGuard(); }, token: NgxFeatureToggleCanLoadGuard, providedIn: "root" });
        return NgxFeatureToggleCanLoadGuard;
    }());

    exports.FeatureToggleDirective = FeatureToggleDirective;
    exports.FeatureToggleModule = FeatureToggleModule;
    exports.FeatureToggleProviderComponent = FeatureToggleProviderComponent;
    exports.FeatureToggleWhenDisabledDirective = FeatureToggleWhenDisabledDirective;
    exports.NgxFeatureToggleCanActivateChildGuard = NgxFeatureToggleCanActivateChildGuard;
    exports.NgxFeatureToggleCanActivateGuard = NgxFeatureToggleCanActivateGuard;
    exports.NgxFeatureToggleCanLoadGuard = NgxFeatureToggleCanLoadGuard;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-feature-toggle.umd.js.map
