import { Directive, TemplateRef, ViewContainerRef, Input, Component, NgModule, isDevMode, Injectable, ɵɵdefineInjectable } from '@angular/core';
import { isOn, set } from 'feature-toggle-service';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FeatureToggleDirective = /** @class */ (function () {
    function FeatureToggleDirective(templateRef, viewContainer) {
        this.templateRef = templateRef;
        this.viewContainer = viewContainer;
        this.isOn = false;
    }
    /**
     * @return {?}
     */
    FeatureToggleDirective.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (!this.featureToggle) {
            throw new Error('Attribute `featureToggle` should not be null or empty');
        }
        this.shouldRender();
    };
    /**
     * @return {?}
     */
    FeatureToggleDirective.prototype.ngDoCheck = /**
     * @return {?}
     */
    function () {
        if (this.isOn !== isOn(this.featureToggle)) {
            this.shouldRender();
        }
    };
    /**
     * @private
     * @return {?}
     */
    FeatureToggleDirective.prototype.shouldRender = /**
     * @private
     * @return {?}
     */
    function () {
        this.isOn = isOn(this.featureToggle);
        if (this.isOn) {
            this.viewContainer.createEmbeddedView(this.templateRef);
        }
        else {
            this.viewContainer.clear();
        }
    };
    FeatureToggleDirective.decorators = [
        { type: Directive, args: [{
                    // tslint:disable-next-line: directive-selector
                    selector: '[featureToggle]',
                },] }
    ];
    /** @nocollapse */
    FeatureToggleDirective.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ViewContainerRef }
    ]; };
    FeatureToggleDirective.propDecorators = {
        featureToggle: [{ type: Input }]
    };
    return FeatureToggleDirective;
}());
if (false) {
    /** @type {?} */
    FeatureToggleDirective.prototype.featureToggle;
    /**
     * @type {?}
     * @private
     */
    FeatureToggleDirective.prototype.isOn;
    /**
     * @type {?}
     * @private
     */
    FeatureToggleDirective.prototype.templateRef;
    /**
     * @type {?}
     * @private
     */
    FeatureToggleDirective.prototype.viewContainer;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FeatureToggleWhenDisabledDirective = /** @class */ (function () {
    function FeatureToggleWhenDisabledDirective(templateRef, viewContainer) {
        this.templateRef = templateRef;
        this.viewContainer = viewContainer;
        this.isOn = false;
    }
    /**
     * @return {?}
     */
    FeatureToggleWhenDisabledDirective.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (!this.featureToggleWhenDisabled) {
            throw new Error('Attribute `featureToggleWhenDisabled` should not be null or empty');
        }
        this.shouldRender();
    };
    /**
     * @return {?}
     */
    FeatureToggleWhenDisabledDirective.prototype.ngDoCheck = /**
     * @return {?}
     */
    function () {
        if (this.isOn !== isOn(this.featureToggleWhenDisabled)) {
            this.shouldRender();
        }
    };
    /**
     * @return {?}
     */
    FeatureToggleWhenDisabledDirective.prototype.shouldRender = /**
     * @return {?}
     */
    function () {
        this.isOn = isOn(this.featureToggleWhenDisabled);
        if (!this.isOn) {
            this.viewContainer.createEmbeddedView(this.templateRef);
        }
        else {
            this.viewContainer.clear();
        }
    };
    FeatureToggleWhenDisabledDirective.decorators = [
        { type: Directive, args: [{
                    // tslint:disable-next-line: directive-selector
                    selector: '[featureToggleWhenDisabled]',
                },] }
    ];
    /** @nocollapse */
    FeatureToggleWhenDisabledDirective.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ViewContainerRef }
    ]; };
    FeatureToggleWhenDisabledDirective.propDecorators = {
        featureToggleWhenDisabled: [{ type: Input }]
    };
    return FeatureToggleWhenDisabledDirective;
}());
if (false) {
    /** @type {?} */
    FeatureToggleWhenDisabledDirective.prototype.featureToggleWhenDisabled;
    /**
     * @type {?}
     * @private
     */
    FeatureToggleWhenDisabledDirective.prototype.isOn;
    /**
     * @type {?}
     * @private
     */
    FeatureToggleWhenDisabledDirective.prototype.templateRef;
    /**
     * @type {?}
     * @private
     */
    FeatureToggleWhenDisabledDirective.prototype.viewContainer;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FeatureToggleProviderComponent = /** @class */ (function () {
    function FeatureToggleProviderComponent() {
        this.features = {};
        this.currentConfig = {};
    }
    /**
     * @return {?}
     */
    FeatureToggleProviderComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (typeof this.features !== 'object') {
            throw new Error('Attribute `features` should not be null or empty');
        }
        this.setFeatureToggles();
    };
    /**
     * @return {?}
     */
    FeatureToggleProviderComponent.prototype.ngDoCheck = /**
     * @return {?}
     */
    function () {
        this.setFeatureToggles();
    };
    /**
     * @private
     * @return {?}
     */
    FeatureToggleProviderComponent.prototype.setFeatureToggles = /**
     * @private
     * @return {?}
     */
    function () {
        if (this.currentConfig !== this.features) {
            this.currentConfig = this.features;
            set(this.features);
        }
    };
    FeatureToggleProviderComponent.decorators = [
        { type: Component, args: [{
                    selector: 'feature-toggle-provider',
                    template: "\n    <ng-content></ng-content>\n  "
                }] }
    ];
    FeatureToggleProviderComponent.propDecorators = {
        features: [{ type: Input }]
    };
    return FeatureToggleProviderComponent;
}());
if (false) {
    /** @type {?} */
    FeatureToggleProviderComponent.prototype.features;
    /**
     * @type {?}
     * @private
     */
    FeatureToggleProviderComponent.prototype.currentConfig;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FeatureToggleModule = /** @class */ (function () {
    function FeatureToggleModule() {
    }
    FeatureToggleModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [FeatureToggleProviderComponent, FeatureToggleDirective, FeatureToggleWhenDisabledDirective],
                    exports: [FeatureToggleProviderComponent, FeatureToggleDirective, FeatureToggleWhenDisabledDirective],
                    imports: [CommonModule],
                },] }
    ];
    return FeatureToggleModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxFeatureToggleCanActivateGuard = /** @class */ (function () {
    function NgxFeatureToggleCanActivateGuard() {
    }
    /**
     * @return {?}
     */
    NgxFeatureToggleCanActivateGuard.prototype.isDevMode = /**
     * @return {?}
     */
    function () {
        return isDevMode();
    };
    /**
     * @param {?} route
     * @return {?}
     */
    NgxFeatureToggleCanActivateGuard.prototype.canActivate = /**
     * @param {?} route
     * @return {?}
     */
    function (route) {
        /** @type {?} */
        var DEV_MODE = this.isDevMode();
        if (!route || !route.data || !route.data.featureToggle) {
            if (DEV_MODE) {
                console.error('`NgxFeatureToggleCanActivateGuard` need to receive `featureToggle` as data in your route configuration.');
            }
            return false;
        }
        if (!Array.isArray(route.data.featureToggle)) {
            if (DEV_MODE) {
                console.error('`NgxFeatureToggleCanActivateGuard` need to receive `featureToggle` as data as an array in your route configuration.');
            }
            return false;
        }
        /** @type {?} */
        var userCanAccess = route.data.featureToggle.every((/**
         * @param {?} toggle
         * @return {?}
         */
        function (toggle) {
            return toggle[0] === '!' ? !isOn(toggle.replace('!', '')) : isOn(toggle);
        }));
        return userCanAccess;
    };
    NgxFeatureToggleCanActivateGuard.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ NgxFeatureToggleCanActivateGuard.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgxFeatureToggleCanActivateGuard_Factory() { return new NgxFeatureToggleCanActivateGuard(); }, token: NgxFeatureToggleCanActivateGuard, providedIn: "root" });
    return NgxFeatureToggleCanActivateGuard;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxFeatureToggleCanActivateChildGuard = /** @class */ (function () {
    function NgxFeatureToggleCanActivateChildGuard() {
    }
    /**
     * @return {?}
     */
    NgxFeatureToggleCanActivateChildGuard.prototype.isDevMode = /**
     * @return {?}
     */
    function () {
        return isDevMode();
    };
    /**
     * @param {?} route
     * @return {?}
     */
    NgxFeatureToggleCanActivateChildGuard.prototype.canActivateChild = /**
     * @param {?} route
     * @return {?}
     */
    function (route) {
        /** @type {?} */
        var DEV_MODE = this.isDevMode();
        if (!route || !route.data || !route.data.featureToggle) {
            if (DEV_MODE) {
                console.error('`NgxFeatureToggleCanActivateChildGuard` need to receive `featureToggle` as data in your route configuration.');
            }
            return false;
        }
        if (!Array.isArray(route.data.featureToggle)) {
            if (DEV_MODE) {
                console.error('`NgxFeatureToggleCanActivateChildGuard` need to receive `featureToggle` as data as an array in your route configuration.');
            }
            return false;
        }
        /** @type {?} */
        var userCanAccess = route.data.featureToggle.every((/**
         * @param {?} toggle
         * @return {?}
         */
        function (toggle) {
            return toggle[0] === '!' ? !isOn(toggle.replace('!', '')) : isOn(toggle);
        }));
        return userCanAccess;
    };
    NgxFeatureToggleCanActivateChildGuard.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ NgxFeatureToggleCanActivateChildGuard.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgxFeatureToggleCanActivateChildGuard_Factory() { return new NgxFeatureToggleCanActivateChildGuard(); }, token: NgxFeatureToggleCanActivateChildGuard, providedIn: "root" });
    return NgxFeatureToggleCanActivateChildGuard;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxFeatureToggleCanLoadGuard = /** @class */ (function () {
    function NgxFeatureToggleCanLoadGuard() {
    }
    /**
     * @return {?}
     */
    NgxFeatureToggleCanLoadGuard.prototype.isDevMode = /**
     * @return {?}
     */
    function () {
        return isDevMode();
    };
    /**
     * @param {?} route
     * @return {?}
     */
    NgxFeatureToggleCanLoadGuard.prototype.canLoad = /**
     * @param {?} route
     * @return {?}
     */
    function (route) {
        /** @type {?} */
        var DEV_MODE = this.isDevMode();
        if (!route || !route.data || !route.data.featureToggle) {
            if (DEV_MODE) {
                console.error('`NgxFeatureToggleCanLoadGuard` need to receive `featureToggle` as data in your route configuration.');
            }
            return false;
        }
        if (!Array.isArray(route.data.featureToggle)) {
            if (DEV_MODE) {
                console.error('`NgxFeatureToggleCanLoadGuard` need to receive `featureToggle` as data as an array in your route configuration.');
            }
            return false;
        }
        /** @type {?} */
        var userCanAccess = route.data.featureToggle.every((/**
         * @param {?} toggle
         * @return {?}
         */
        function (toggle) {
            return toggle[0] === '!' ? !isOn(toggle.replace('!', '')) : isOn(toggle);
        }));
        return userCanAccess;
    };
    NgxFeatureToggleCanLoadGuard.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ NgxFeatureToggleCanLoadGuard.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgxFeatureToggleCanLoadGuard_Factory() { return new NgxFeatureToggleCanLoadGuard(); }, token: NgxFeatureToggleCanLoadGuard, providedIn: "root" });
    return NgxFeatureToggleCanLoadGuard;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { FeatureToggleDirective, FeatureToggleModule, FeatureToggleProviderComponent, FeatureToggleWhenDisabledDirective, NgxFeatureToggleCanActivateChildGuard, NgxFeatureToggleCanActivateGuard, NgxFeatureToggleCanLoadGuard };
//# sourceMappingURL=ngx-feature-toggle.js.map
